



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Linux记录-监控系统开发</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Linux记录-监控系统开发</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-14 13:32:58 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>需求：使用shell定制各种个性化告警工具，但需要统一化管理、规范化管理。<br />思路：指定一个脚本包，包含主程序、子程序、配置文件、邮件引擎、输出日志等。<br />主程序：作为整个脚本的入口，是整个系统的命脉。<br />配置文件：是一个控制中心，用它来开关各个子程序，指定各个相关联的日志文件。<br />子程序：这个才是真正的监控脚本，用来监控各个指标。<br />邮件引擎：是由一个python程序来实现，它可以定义发邮件的服务器、发邮件人以及发件人密码<br />输出日志：整个监控系统要有日志输出。<br />要求：我们的机器角色多种多样，但是所有机器上都要部署同样的监控系统，也就说所有机器不管什么角色，整个程序框架都是一致的，不同的地方在于根据不同的角色，定制不同的配置文件。<br />程序架构：&nbsp;<br /><img referrerpolicy="no-referrer"src="https://s1.51cto.com/images/blog/201806/11/c1b04408acb50a77862dcdc90b4e7139.jpg?x-oss-process=image/watermark,size_16,text_QDUxQ1RP5Y2a5a6i,color_FFFFFF,t_100,g_se,x_10,y_10,shadow_90,type_ZmFuZ3poZW5naGVpdGk=" /></p>
<p>bin下是主程序<br />conf下是配置文件<br />shares下是各个监控脚本<br />mail下是邮件引擎<br />log下是日志。</p>
<h1>主脚本</h1>
<pre class="prettyprint linenums"><code>#!/bin/bash<br />
#是否发送邮件的开关<br />
export send=1<br />
#过滤ip地址<br />
export addr=`/sbin/ifconfig |grep -A1 "ens33: "|awk '/inet/ {print $2}'`<br />
dir=`pwd`<br />
#只需要最后一级目录名<br />
last_dir=`echo $dir|awk -F'/' '{print $NF}'`<br />
#下面的判断目的是，保证执行脚本的时候，我们在bin目录里，不然监控脚本、邮件和日志很有可能找不到<br />
if [ $last_dir == "bin" ] || [ $last_dir == "bin/" ]; then<br />
    conf_file="../conf/mon.conf"<br />
else<br />
    echo "you shoud cd bin dir"<br />
    exit<br />
fi<br />
exec 1&gt;&gt;../log/mon.log 2&gt;&gt;../log/err.log<br />
echo "`date +"%F %T"` load average"<br />
/bin/bash ../shares/load.sh<br />
#先检查配置文件中是否需要监控502<br />
if grep -q 'to_mon_502=1' $conf_file; then<br />
    export log=`grep 'logfile=' $conf_file |awk -F '=' '{print $2}' |sed 's/ //g'`<br />
    /bin/bash  ../shares/502.sh<br />
fi</code></pre>
<h1>配置文件</h1>
<p>vim mon/conf/mon.conf</p>
<pre class="prettyprint linenums"><code>##to config the options if to monitor<br />
##定义mysql的服务器地址、端口以及user、password<br />
to_mon_cdb=0   ##0 or 1, default 0,0 not monitor, 1 monitor<br />
db_ip=10.20.3.13<br />
db_port=3315<br />
db_user=username<br />
db_pass=passwd<br />
##httpd   如果是1则监控，为0不监控<br />
to_mon_httpd=0<br />
##php 如果是1则监控，为0不监控<br />
to_mon_php_socket=0<br />
##http_code_502  需要定义访问日志的路径<br />
to_mon_502=1<br />
logfile=/data/log/xxx.xxx.com/access.log<br />
##request_count   定义日志路径以及域名<br />
to_mon_request_count=0<br />
req_log=/data/log/www.discuz.net/access.log<br />
domainname=www.discuz.net</code></pre>
<h1>监控项目</h1>
<p>1 负载监控<br />vim /mon/shares/load.sh</p>
<pre class="prettyprint linenums"><code>#! /bin/bash<br />
load=`uptime |awk -F 'average:' '{print $2}'|cut -d',' -f1|sed 's/ //g' |cut -d. -f1`<br />
if [ $load -gt 10 ] &amp;&amp; [ $send -eq "1" ]<br />
then<br />
    echo "$addr `date +%T` load is $load" &gt;../log/load.tmp<br />
    /bin/bash ../mail/mail.sh lvlinux@163.com "$addr\_load:$load"  "`cat ../log/load.tmp`"<br />
fi<br />
echo "`date +%T` load is $load"</code></pre>
<p>2 502错误监控<br />vim mon/shares/502.sh</p>
<pre class="prettyprint linenums"><code>#! /bin/bash<br />
d=`date -d "-1 min" +%H:%M`<br />
c_502=`grep :$d:  $log   |grep ' 502 '|wc -l`<br />
if [ $c_502 -gt 10 ] &amp;&amp; [ $send == 1 ]; then<br />
     echo "$addr $d 502 count is $c_502"&gt;../log/502.tmp<br />
     /bin/bash ../mail/mail.sh  lvlinux@163.com   "$addr\_502 $c_502"   "`cat    ../log/502.tmp`"<br />
fi<br />
echo "`date +%T` 502 $c_502"</code></pre>
<p>3 硬盘监控<br />vim mon/shares/disk.sh</p>
<pre class="prettyprint linenums"><code>#! /bin/bash<br />
rm -f ../log/disk.tmp<br />
for r in `df -h |awk -F '[ %]+' '{print $5}'|grep -v Use`<br />
do<br />
    if [ $r -gt 90 ] &amp;&amp; [ $send -eq "1" ]<br />
then<br />
    echo "$addr `date +%T` disk useage is $r" &gt;&gt;../log/disk.tmp<br />
fi<br />
if [ -f ../log/disk.tmp ]<br />
then<br />
    df -h &gt;&gt; ../log/disk.tmp<br />
    /bin/bash ../mail/mail.sh  lvlinux@163.com   "$addr\_disk$r"   "` cat ../log/disk.tmp`"<br />
    echo "`date +%T` disk useage is nook"<br />
else<br />
    echo "`date +%T` disk useage is ok"<br />
fi</code></pre>
<h1>告警脚本</h1>
<p>vim mail.sh</p>
<pre class="prettyprint linenums"><code>log=$1   //给变量log赋值<br />
t_s=`date +%s`  //定义当前绝对时间戳，单位为秒<br />
t_s2=`date -d "2 hours ago" +%s` //定义上次告警时间戳，用作第一次发现异常<br />
if [ ! -f /tmp/$log ]<br />
then<br />
    echo $t_s2 &gt; /tmp/$log<br />
fi      //将上次告警时间戳写入日志，用作第一次发现异常<br />
t_s2=`tail -1 /tmp/$log|awk '{print $1}'`    //从日志取出上次告警时间戳<br />
echo $t_s &gt;&gt; /tmp/$log     //将本次告警时间戳追加到日志<br />
v=$[$t_s-$t_s2]    //计算两次告警相隔时间<br />
if [ $v -gt 3600 ]<br />
then<br />
    ../mail/mail.py $1 $2 "$3" //当相隔超过一小时，发送邮件，提醒有故障发生。<br />
    echo "0" &gt; /tmp/$log.txt<br />
else<br />
    if [ ! -f /tmp/$log.txt ]<br />
    then<br />
        echo "0" &gt; /tmp/$log.txt<br />
    fi<br />
    nu=`cat /tmp/$log.txt`<br />
    nu2=$[$nu+1]<br />
    echo $nu2 &gt; /tmp/$log.txt<br />
    if [ $nu2 -gt 10 ]<br />
    then<br />
        ../mail/mail.py $1 "trouble continue 10 min  $2 " "$3"<br />
         echo "0" &gt; /tmp/$log.txt<br />
    fi<br />
fi  //相隔小于一小时，启动计数器，计数器大于10发送邮件，提醒故障持续了10分钟。</code></pre>
<h1>发邮件脚本</h1>
<p>vim mail.py</p>
<pre class="prettyprint linenums"><code>#!/usr/bin/env python<br />
#-*- coding: UTF-8 -*-<br />
import os,sys<br />
reload(sys)<br />
sys.setdefaultencoding('utf8')<br />
import getopt<br />
import smtplib<br />
from email.MIMEText import MIMEText<br />
from email.MIMEMultipart import MIMEMultipart<br />
from  subprocess import *<br />
def sendqqmail(username,password,mailfrom,mailto,subject,content):<br />
    gserver = 'smtp.qq.com'    //更具实际情况作更改<br />
    gport = 25<br />
    try:<br />
        msg = MIMEText(unicode(content).encode('utf-8'))<br />
        msg['from'] = mailfrom<br />
        msg['to'] = mailto<br />
        msg['Reply-To'] = mailfrom<br />
        msg['Subject'] = subject<br />
        smtp = smtplib.SMTP(gserver, gport)<br />
        smtp.set_debuglevel(0)<br />
        smtp.ehlo()<br />
        smtp.login(username,password)<br />
        smtp.sendmail(mailfrom, mailto, msg.as_string())<br />
        smtp.close()<br />
    except Exception,err:<br />
        print "Send mail failed. Error: %s" % err<br />
def main():<br />
    to=sys.argv[1]<br />
    subject=sys.argv[2]<br />
    content=sys.argv[3]<br />
##定义QQ邮箱的账号和密码，你需要修改成你自己的账号和密码<br />
 sendqqmail('1234567@qq.com','aaaaaaaaaa','1234567@qq.com',to,subject,content)<br />
if __name__ == "__main__":<br />
    main()</code></pre>
<h1>两个问题</h1>
<p>1 告警收敛脚本原理<br />首先明白一个前提，我们是发现问题才会告警发邮件通知，那么当告警脚本未加载时，说名当前监控项正常。或者之前出现异常，但是已经恢复。<br />我们写这个脚本的目的是防止问题出现，处于修复期的频繁告警。那么我们就要去判断这是一个新的异常，还是一个已发现的故障。我们可以定义一个时间阈值，一小时。比如距离上一次问题出现，也就是距离上一次告警的时间大于一小时，我们认为就是一个新的异常，否则就是一个尚未解决的故障。<br />具体怎么实现了，我们可以借助记录日志的思想，每次告警，我们都记录一个绝对时间戳，当下一次告警到来时，用当前时间戳减去上一次报警的时间戳，然后if判断该差值，从而确定告警动作。<br />在具体脚本中定义t2为上一次告警时间戳，t1为当前时间戳，t1-t2就是我们要的判断值。t1可以用命令直接获取，t1=`date +%s` t2 要从日志中获取。但是还有一个问题，对于第一次告警，该t2从哪里来了，也简单，我们自己定义一个满足新异常条件的时间戳就可以，比如两小时之前。<br />t2=`date -d "two hours ago" +%s`<br />对于一个已发现待解决的故障，也就是对应上面时间戳差值小于一小时的情况，如果我们的脚本是一分钟执行一次，就可以做一个计数器，每发现一次，计数一次，当计数器大于10时，也就是异常持续了10分钟，这时候发送邮件一次，同时清空计时器。<br />2 $1 $2 $3 参数传递问题<br />因为mail.py 脚本决定了发送邮件必须带三个参数，收件人邮箱，主题， 内容。因此mail.sh 调用mail.py 必须传递给它三个参数，那么这三个参数最终来自哪里呢，来自监控项脚本，比如load.sh<br />传递顺序为 load.sh----&gt;mail.sh-----&gt;mail.py<br />再解释mail.sh 第一行，log=$1 , 是一个变量赋值语句，此时的$1就是load.sh 传递过来的邮箱名称。<br />在程序中我么看到后面将时间戳保存在了/tmp/$log 下面，该复制语句是为了给该日志文件取一个有意义的名称，便于以后管理。当然可以给出其他赋值，比如log=time.txt</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqv3m3z8.html">Java中的GOF23（23中设计模式）--------- 单例模式（Singleton）</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyl21x8.html">第二章平稳时间序列模型&mdash;&mdash;ACF和PACF和样本ACF&sol;PACF</a>
		</li>
						<li><a href="https://www.batexi.com/a/r9311kz8.html">《zw版&amp;&num;183&semi;Halcon-delphi系列原创教程》 Halcon分类函数002&amp;&num;183&semi;AI人工智能</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlr6leq.html">android listview用adapter&period;notifyDataSetChanged&lpar;&rpar;无法刷新每项的图标</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o71opq.html">Python打包程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd46le8.html">hdu2023 求平均成绩 ~~很闲~~~</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdel4l09.html">自己写的一个Js小插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvo7noq.html">用powerdesigner建模工具生成数据库</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vnzx38.html">蓝桥杯--算法训练 区间k大数查询</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2we0rxq.html">史上最全的iOS各种设备信息获取总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x5orr9.html">linux之SQL语句简明教程---BETWEEN</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jmxvv8.html">location下的属性集锦</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y1xkn8.html">●BZOJ 4289 PA2012 Tax</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjyl538.html">数据库的事务、ACID及隔离级别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyy3mgq.html">使用Laya引擎开发微信小游戏（上）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ojmpj8.html">Shell脚本 &vert; 截取包名</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv274zx9.html">React学习笔记&lowbar;01</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllrwpxq.html">HeadFirst Ruby 第十章总结 Comparable &amp;amp&semi; Enumerable</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpeynz9.html">RecyclerView的使用（2）之多Item布局的载入</a>
		</li>
						<li><a href="https://www.batexi.com/a/902jxljq.html">数据库与hadoop与分布式文件系统的区别和联系</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qv2dmry9.html">【XSY2715】回文串 树链剖分 回文自动机</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wj4v0q.html">MT【306】圆与椭圆公切线段</a>
			</li>
						<li><a href="https://www.batexi.com/a/960mr249.html">【HDU - 5790 】Prefix（主席树&plus;Trie树）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2dl3y9.html">自学Python之路-Python基础&plus;模块&plus;面向对象&plus;函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllo6yeq.html">iptables&lpar;4&rpar;规则编写</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwmzmd8.html">20165223《Java程序设计》第九周Java学习总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdl1yd9.html">使用Disruptor实现生产者和消费者模型</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1d765q.html">javascript正则表达式---正向预查</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlloz36q.html">SpaceVim中vimproc的vimproc&lowbar;linux64&period;so未找到</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gj41z79.html">【UVA1194】Machine Schedule</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
